#include<stdio.h>
#include<stdlib.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<string.h>
#include<arpa/inet.h>
#include<unistd.h>
#include <poll.h>

int main(void) {
    /* CREATE SOCKET */
    int sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock == -1) {
        perror("SOCKET COULD NOT BE OPENED");
        exit(EXIT_FAILURE);
    }

    /* CREATE SERVER ADDRESS */
    struct sockaddr_in serverAddr;
    memset(&serverAddr, 0, sizeof(struct sockaddr_in));
    serverAddr.sin_family = AF_INET;
    serverAddr.sin_port = htons(54321);
    serverAddr.sin_addr.s_addr = htonl(INADDR_ANY);
    socklen_t serverAddrLen = sizeof(struct sockaddr_in);

    /* SEND msg1 */
    char const* msg1 = "Hello!\n";
    size_t msgLen = strlen(msg1);
    if(sendto(sock, msg1, msgLen, 0,
        (struct sockaddr*)&serverAddr, serverAddrLen) == -1) {
        perror("FAILED TO SEND msg1");
        exit(EXIT_FAILURE);
    }

    /* CREATE POLL STRUCTURE */
    size_t const NFDS = 1;
    struct pollfd fds[NFDS];
    memset(fds, 0 , sizeof(fds));
    fds[0].fd = sock;
    fds[0].events = POLLIN;

    /* SET TIMEOUT IN MILLISECONDS */
    size_t const TIMEOUT = 5 * 1000;
    
    /* RECEIVE MESSAGES FROM SERVER */
    size_t const BUFFSIZE = 256;
    char recvBuff[BUFFSIZE];
    while(poll(fds, NFDS, TIMEOUT)) {
        if(recvfrom(sock, recvBuff, BUFFSIZE, 0,
            (struct sockaddr*)&serverAddr, &serverAddrLen) == -1) {
            perror("FAILED TO RECEIVE msg");
            exit(EXIT_FAILURE);
        }
        printf("%s", recvBuff);
    }
}