#include<stdio.h>
#include<stdlib.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<string.h>
#include<arpa/inet.h>
#include<unistd.h>
#include <poll.h>

int main(void) {
    /* CREATE SOCKET */
    int sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock == -1) {
        perror("SOCKET COULD NOT BE OPENED");
        exit(EXIT_FAILURE);
    }


    /* CREATE SERVER ADDRESS */
    struct sockaddr_in serverAddr;
    memset(&serverAddr, 0, sizeof(struct sockaddr_in));
    serverAddr.sin_family = AF_INET;
    serverAddr.sin_port = htons(54321);
    serverAddr.sin_addr.s_addr = htonl(INADDR_ANY);
    socklen_t serverAddrLen = sizeof(struct sockaddr_in);

    /* CREATE CLIENT ADDRESS */
    struct sockaddr_in clientAddr;
    memset(&clientAddr, 0, sizeof(struct sockaddr_in));
    socklen_t clientAddrLen = sizeof(struct sockaddr_in);

    /* BIND SERVER ADDRESS */
    if (bind(sock, (const struct sockaddr*)&serverAddr,
        serverAddrLen) == -1) { 
        perror("BIND FAILED"); 
        exit(EXIT_FAILURE); 
    } 

    /* RECEIVE msg1 */
    size_t const BUFFSIZE = 256;
    char recvBuff[BUFFSIZE];
    if(recvfrom(sock, recvBuff, BUFFSIZE, 0,
        (struct sockaddr*)&clientAddr, &clientAddrLen) == -1) {
        perror("FAILED TO RECEIVE msg1");
        exit(EXIT_FAILURE);
    }
    printf("%s", recvBuff);
    sleep(3);

    /* SEND MESSAGES TO CLIENT */
    char const* msgs[] = {"We're no strangers to love\n",
                        "You know the rules and so do I\n",
                        "A full commitment's what I'm thinking of\n",
                        "You wouldn't get this from any other guy\n"};
    size_t const MSGS_SIZE = sizeof(msgs) / sizeof(msgs[0]);
    size_t msgLen; 
    for(size_t i = 0; i < MSGS_SIZE; ++i) {
        msgLen = strlen(msgs[i]);
        sendto(sock, msgs[i], msgLen, 0,
            (struct sockaddr*)&clientAddr, clientAddrLen);
        sleep(3);
    }
}